import os
import commands


# Max number of jobs I allow myself to launch
nbJobMax = 300
nbJobCommand = "qstat | grep username | wc -l" # Indicate username to get the number of jobs currently running


rotx = (0, 5, 10, 15, 20, 25, 30)
roty = 0
rotz = 0

tx = (0, 15, 22, 30, 37, 45)
ty = 0
tz = 0

sigma = (0, 30, 45, 60, 75)


r2 = roty
r3 = rotz

t2 = ty
t3 = tz

# Loop that generates sets of parameters to be passed to the qsub command
# To be modified depending on the parameters to test
for r1 in rotx:
    for t1 in tx:
        for sig in sigma:
            # I first look whether I can still launch a job
            currNbJob = int(commands.getoutput(nbJobCommand))
            if currNbJob > nbJobMax:
                print "\nOn a deja",currNbJob,"jobs qui tournent. On attend donc avant d'en lancer de nouveaux ..."
                while currNbJob > nbJobMax:
                    # We have to wait before launching a new job
                    print "..... On attend car currNbJob = ",currNbJob,"et nbJobMax =",nbJobMax
                    os.system("sleep 5")
                    currNbJob = int(commands.getoutput(nbJobCommand))
                                    
            # Ok to launch a new job
            print "\nTout est ok on lance un job ... avec les parametres suivant :",r1,r2,r3,t1,t2,t3,sig

            rot = "rotx=%d,roty=%d,rotz=%d," %(r1,r2,r3)
            trans = "tx=%d,ty=%d,tz=%d," %(t1,t2,t3)
            # Build command
            my_command = "qsub qsubCommand.pbs -v DISPLAY=$DISPLAY," + rot + trans + "sigma=" + str(sig)
            os.system("wakeup-nodes") # Wake nodes up (if asleep, during the week-end for example)
            os.system(my_command) # Call qsub command
            os.system("sleep 0.01")
