import os
import sys

# Get arguments from the .pbs file

# Rotations
rotx = sys.argv[1]
roty = sys.argv[2]
rotz = sys.argv[3]

# Translations
tx = sys.argv[4]
ty = sys.argv[5]
tz = sys.argv[6]

# Sigma
sig = sys.argv[7]

# NOTE: Paths and filenames must be set depending on the user and the directories where data is stored


# Step 1: Generate transformed images with executable rotate3D

TransFormExe = "rotate3D"

imageToTransform = "t2_icbm_normal_1mm_pn0_rf0.hdr"
outputTransformedName = # name of the output image
matTransfoName = # indicate the name of the output transformation matrix

# Build command
TransformCommand = " ".join([TransFormExe, imageToTransform, rotx, roty, rotz, tx, ty, tz, outputTransformedName, matTransfoName])

os.system(TransformCommand) # Transform the image
os.system("sleep 5")


# -----------------------------------------------------------


# Step 2: Add noise to transformed image

addnoiseExe = "AddNoise2Image"
inputNoiseImageName = # = name of the output image from Step 1
outputNoiseImageName = # name of the output image with noise added

addNoiseCommand = " ".join([addnoiseExe, inputNoiseImageName, outputNoiseImageName, sig])

os.system(addNoiseCommand)
os.system("sleep 5")


# -----------------------------------------------------------


# Step 3: Register

# NOTE: We register the T2 transformed on the T1 

RegExe = # registration executable
fixedImage =  # name of the image used as reference in the registration process
movingImage = # at this step the moving image is the T2 transformed at step 1 & 2
outputName = 
resMatrixFileName = 
timeFile = 

# At this step best parameters from Phase 1 are set
nbHistBins = 100
nbSpatialSamples = 204800

# Register
RegCommand = " ".join([RegExe, fixedImage, movingImage, outputName, str(nbHistBins), str(nbSpatialSamples), resMatrixFileName, timeFile])

# Launch registration command
os.system(RegCommand)
os.system("sleep 5")

